package dwtcpcustom;

import java.io.StringReader;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Unmarshaller;

import com.ils_tech.dw.ei.DWCustomDataHolder;
import com.ils_tech.dw.ei.DWCustomRequestHelper;
import org.apache.log4j.Category;

public class DWTransformCustom implements DWCustomRequestHelper{

	private static Category logger = Category.getInstance(DWTransformCustom.class.getName());
	
	@Override
	public String formatErrorMessage(String mapName, int errCode, String data) {
		// TODO Auto-generated method stub
		return mapName + ": Error code:" + errCode;
	}
	
	WWKS inputRequest;
	String response;
	String Id;

	@Override
	public String getMap(String sourceData) {
		// TODO Auto-generated method stub
		try {
			JAXBContext context = JAXBContext.newInstance(WWKS.class);
			Unmarshaller un = context.createUnmarshaller();
			StringReader reader = new StringReader(sourceData.concat("\n</WWKS>"));

			inputRequest = (WWKS) un.unmarshal(reader);
			
		} catch (JAXBException e) {

			System.out.println("JAXBException: " + e.getMessage());
		}
		
		return "hello_request";
	}
	
	public Object transformCustomtcpHelloRequest(DWCustomDataHolder input) {
		DWCustomDataHolder req = input;
		req.getItems().put("Id", inputRequest.getHobj().getId());
		req.getItems().put("SubId",inputRequest.getHobj().getSobj().getId());
		return (req);
	}

	public Object transformCustomtcpHelloResponse(DWCustomDataHolder input) {
		 response = "<Response>Success</Response>";
		return (response.getBytes());
	}
	
	
	/*
	 * public static void main(String[] args) {
	 * 
	 * String xml = "<WWKS Version=\"2.0\" TimeStamp=\"2017-05-13T18:20:00Z\">\r\n"
	 * + "	<HelloRequest Id=\"1001\">\r\n" +
	 * "		<Subscriber Id=\"100\" Type=\"IMS\" Manufacturer=\"IT-SysProvider\" ProductInfo=\"PharmaProg 2013\" VersionInfo=\"1.4.0\" TenantId=\"XAB12345\">\r\n"
	 * + "			<Capability Name=\"KeepAlive\"/>\r\n" +
	 * "			<Capability Name=\"ArticleInfo\"/>\r\n" +
	 * "			<Capability Name=\"StockInfo\"/>\r\n" +
	 * "			<Capability Name=\"Input\"/>\r\n" +
	 * "			<Capability Name=\"Output\"/>\r\n" + "		</Subscriber>\r\n" +
	 * "	</HelloRequest>\r\n" + "";
	 * 
	 * DWTransformCustom cust = new DWTransformCustom(); cust.getMap(xml); }
	 */

}
